// TODO:
// + check entered values in settingsdialog
// + check if using doublebuffer 
// + store agents' position into statistics too
//   energy_level, x, y, dir
// + some algaes are drawn over others
// + selection of agents causes some confusing selections
// + because of some badly used indices, exception occures if width!=height
// - nullpointer-exception if simulation-windows is closed and simulation running
   
import algae.simulation.*;
import algae.simulation.BatchWC;
import algae.simulation.GUIWC;
import algae.gui.SettingsDialog;

import java.io.*;
import java.util.*;
import java.util.Date;
import java.text.DateFormat;
import com.sun.xml.parser.Resolver;
import com.sun.xml.tree.*;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.w3c.dom.*;

public final class Main {	
 
     static Settings cfg;

     static void ImportSimulationSettings(org.w3c.dom.Node xn)
     {
    	cfg.duration=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("duration").getNodeValue());
	cfg.width=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("width").getNodeValue());
	cfg.height=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("height").getNodeValue());
	
    	cfg.randSeed=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("randseed").getNodeValue());
    	
    	if (xn.getAttributes().getNamedItem("light_enabled").getNodeValue().equals("all the time"))
    	    cfg.light_enabled=1;
    	if (xn.getAttributes().getNamedItem("light_enabled").getNodeValue().equals("never"))
    	    cfg.light_enabled=0;
    	if (xn.getAttributes().getNamedItem("light_enabled").getNodeValue().equals("function"))
    	    cfg.light_enabled=2;

    	cfg.light_function=-1; // not implemented yet
	cfg.light_cycle_function=-1; // not implemented yet
    	cfg.light_intensity=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("light_intensity").getNodeValue());
    		
	cfg.substrate_amount=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("substrate_amount").getNodeValue());
    	cfg.substrate_renew_rate=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("substrate_renew_rate").getNodeValue());
    	cfg.pheromone_dec_rate=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("pheromone_dec_rate").getNodeValue()); 	
    }

    static void ImportAlgaesSettings(org.w3c.dom.Node xn)
    {
    	cfg.initial_algaes=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("initial_algaes").getNodeValue());
    	cfg.initial_energy=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("initial_energy").getNodeValue());
    }

    static void ImportActionsSettings(org.w3c.dom.Node xn)
    {
   	cfg.energy_movement=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_movement").getNodeValue());
    	cfg.energy_mitose=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_mitose").getNodeValue());
    	cfg.energy_meiose=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_meiose").getNodeValue());
    	cfg.energy_pheromone_output=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_pheromone_output").getNodeValue());
    	cfg.energy_substrate=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_substrate").getNodeValue());
    	cfg.energy_light=java.lang.Float.parseFloat(xn.getAttributes().getNamedItem("energy_light").getNodeValue());
    }

    static void ImportSensorsSettings(org.w3c.dom.Node xn)
    {
    	cfg.pheromone_fov=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("pheromone_fov").getNodeValue());
    	cfg.pheromone_range=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("pheromone_range").getNodeValue());
    	
    	cfg.substrate_fov=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("substrate_fov").getNodeValue());
    	cfg.substrate_range=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("substrate_range").getNodeValue());
    	
    	cfg.light_fov=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("light_fov").getNodeValue());
    	cfg.light_range=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("light_range").getNodeValue());
    	
    	cfg.bumper_range=java.lang.Integer.parseInt(xn.getAttributes().getNamedItem("bumper_range").getNodeValue());
    }
    
    static int ImportSettingsFile(String s)
    {
        File xmlfile=new File(s);
	
	if (!xmlfile.exists())
	{
	     System.out.println("File "+s+" not found ...");
	     return -1;
	}

    	System.out.println("Trying to parse \""+s+"\"");
    	
        XmlDocument xmldoc = new XmlDocument();
        // Load the File
        try 
        {
            InputSource xmlinput = Resolver.createInputSource (xmlfile);
            xmldoc = XmlDocument.createXmlDocument (xmlinput, false);
        }
         
        // Do finer catches !!!!!
         
        catch (SAXParseException err) 
        {   
               System.out.println ("** Parsing error" 
                                   + ", line " + err.getLineNumber ()
                                   + ", uri " + err.getSystemId ());
               System.out.println("   " + err.getMessage ());
        } 
         
        catch (SAXException ex) 
        {
            Exception   x = ex.getException ();
            ((x == null) ? ex : x).printStackTrace ();
        }
            
        catch (Throwable t) 
        {
            t.printStackTrace ();
        }   
      	
      	//// get Root XmlNode
        org.w3c.dom.Node xmlRoot = xmldoc.getDocumentElement();
        NodeList rootChilds = xmlRoot.getChildNodes();
        System.out.println("Rootnodename = "+xmlRoot.getNodeName());
        for (int i=0; i<rootChilds.getLength(); i++) 
        {
            if (rootChilds.item(i).getNodeName().equals("Algaes")) 
            {
            	ImportAlgaesSettings(rootChilds.item(i));
               	System.out.println("Algaes-subsection imported...");
            }
            else 
            if (rootChilds.item(i).getNodeName().equals("Actions")) 
            {
            	ImportActionsSettings(rootChilds.item(i));
               	System.out.println("Actions-subsection found...");
            }
            else 
            if (rootChilds.item(i).getNodeName().equals("Simulation")) 
            {
            	ImportSimulationSettings(rootChilds.item(i));
               	System.out.println("Simulation-subsection found...");
            }
            else 
            if (rootChilds.item(i).getNodeName().equals("Sensors")) 
            {
            	ImportSensorsSettings(rootChilds.item(i));
               	System.out.println("Sensors-subsection found...");
            }
            else System.out.println("Import: Unknown node in XML file (" + rootChilds.item(i).getNodeName() + ")!");
	};
	
	return 0;
    }

     public static void main(String s[])
     {	   
     	   // if parameter is given, in fact a settingsfile,
     	   // we start the batch mode
	   if ((s.length>0))
	   {
	       cfg = new Settings();
	       
	       if (ImportSettingsFile(s[0])==-1)
		   return;

	       BatchWC wc=new BatchWC(cfg,s[0]+".stat");
	      
	       wc.run();	       
	   }  
	   // otherwise go on with the gui
	   else
	   {
	       SettingsDialog sdlg=new SettingsDialog();
	       sdlg.setTitle("Settings dialog");
	       sdlg.setVisible(true);
	       sdlg.setSize(500,350);
	       sdlg.setResizable(true);
	       sdlg.pack();
	   }
     }	
}
